<?php

declare(strict_types=1);

namespace Drupal\role_enum\Attribute;

/**
 * Defines permissions for a role.
 *
 * Does not work with \Drupal\role_enum\Enum\ExternalConfigBackedRoleInterface.
 */
#[\Attribute(flags: \Attribute::TARGET_CLASS_CONSTANT)]
final class Permissions {

  /**
   * Permissions for a role.
   *
   * @param array<string|\Drupal\role_enum\Enum\PermissionsInterface|class-string<\Drupal\role_enum\Enum\PermissionsInterface>> $permissions
   *   An array of strings, or permission enums, or the class string
   *   representing a permission enum class.
   * @param bool $validate
   *   Whether to validate permissions resolve to permissions in Drupal.
   */
  public function __construct(
    public array $permissions,
    public bool $validate = TRUE,
  ) {
  }

}
