<?php

declare(strict_types=1);

namespace Drupal\role_enum\Attribute;

/**
 * An optional attribute for customizing a role definition.
 *
 * Used with enums that do *not* implement ConfigBackedRoleInterface.
 */
#[\Attribute(flags: \Attribute::TARGET_CLASS_CONSTANT)]
final class Role {

  /**
   * A role definition.
   *
   * For permissions, and the equivalent to `is_admin`, use the AllPermissions
   * attribute.
   *
   * @param string|null $label
   *   A label, or leave as NULL and one will be generated automatically.
   * @param int<0, max> $weight
   *   The weight.
   */
  public function __construct(
    public ?string $label,
    public int $weight = 0,
  ) {
  }

}
