<?php

declare(strict_types=1);

namespace Drupal\role_enum\Entity;

use Drupal\role_enum\Enum\RoleInterface as RoleEnumInterface;
use Drupal\user\UserInterface;

/**
 * An interface for the methods in the trait.
 *
 * @see \Drupal\role_enum\Entity\Trait\RoleTrait
 */
interface RoleInterface extends UserInterface {

  /**
   * @return $this
   */
  public function roleEnumAdd(RoleEnumInterface ...$roles);

  /**
   * @return $this
   */
  public function roleEnumRemove(RoleEnumInterface ...$roles);

  public function roleEnumHas(RoleEnumInterface $role): bool;

}
