<?php

declare(strict_types=1);

namespace Drupal\role_enum\EntityProperty;

use Drupal\role_enum\Entity\RoleInterface;

/**
 * Utility for instantiating a role property on a user bundle class.
 */
final class RoleEnumProp {

  private function __construct() {
    // Not instantiable.
  }

  /**
   * Factory for proxy objects.
   *
   * This method should be used rather than calling RoleEnumProxy::init
   * directly.
   *
   * @template T of \Drupal\role_enum\Entity\RoleInterface
   * @phpstan-param T $entity
   * @phpstan-return \Drupal\role_enum\EntityProperty\RoleEnumProxy<T>
   */
  public static function createProperty(RoleInterface $entity): RoleEnumProxy {
    return RoleEnumProxy::init($entity);
  }

}
