<?php

declare(strict_types=1);

namespace Drupal\role_enum\Enum;

interface PermissionsInterface extends \UnitEnum {

  /**
   * The globally unique permission ID.
   *
   * Usually these are a series of lowercase words separated by spaces, with the
   * lowercase module machine name as a prefix.
   *
   * The id() method is used to determine a unique ID, so we don't require
   * string backed enums. Role enums can of course be string backed, just return
   * <code>$this->value</code> in <code>id()</code>.
   */
  public function id(): string;

}
