<?php

declare(strict_types=1);

namespace Drupal\role_enum\Exception;

use Drupal\role_enum\Enum\ConfigBackedRoleInterface;

final class MustBeConfigBackedRoleException extends \Exception {

  private function __construct(
    string $message = "",
    ?\Throwable $previous = NULL,
  ) {
    parent::__construct($message, previous: $previous);
  }

  /**
   * @phpstan-param class-string<\Drupal\role_enum\Enum\RoleInterface> $originalClassName
   */
  public static function create(string $originalClassName): static {
    return new static(\sprintf('An instance of %s is required but an instance of %s was passed instead.', ConfigBackedRoleInterface::class, $originalClassName));
  }

}
