<?php

declare(strict_types=1);

namespace Drupal\role_enum;

/**
 * @internal
 */
final readonly class PermissionMapping {

  /**
   * @phpstan-param array<class-string<\Drupal\role_enum\Enum\PermissionsInterface>, string> $enumClasses
   * @internal
   */
  public function __construct(
    private array $enumClasses,
  ) {
  }

  /**
   * @phpstan-return array<class-string<\Drupal\role_enum\Enum\PermissionsInterface>>
   */
  public function getEnumClasses(): array {
    return \array_keys($this->enumClasses);
  }

  /**
   * Get the name of the extension implementing this enum.
   */
  public function getProvider(string $enumClass): string {
    return $this->enumClasses[$enumClass] ?? throw new \Exception('No provider found for `' . $enumClass . '`');
  }

}
