<?php

declare(strict_types=1);

namespace Drupal\role_enum_test\Entity;

use Drupal\bca\Attribute\Bundle;
use Drupal\role_enum\Entity\RoleInterface;
use Drupal\role_enum\Entity\Trait\RoleTrait;
use Drupal\role_enum\EntityProperty\RoleEnumProxy;
use Drupal\user\Entity\User;

#[Bundle(
  entityType: 'user',
  bundle: 'user',
)]
final class RoleEnumTestUser extends User implements RoleInterface {

  use RoleTrait;

  /**
   * @phpstan-var \Drupal\role_enum\EntityProperty\RoleEnumProxy<$this>
   */
  public RoleEnumProxy $r;

  public function __construct(
    array $values,
    string $entity_type,
    string|null|false $bundle = FALSE,
    array $translations = [],
  ) {
    parent::__construct($values, $entity_type, $bundle, $translations);

    $this->r = RoleEnumProxy::init($this);
  }

}
