<?php

declare(strict_types=1);

namespace Drupal\role_enum_test\Role;

use Drupal\role_enum\Attribute\Permissions;
use Drupal\role_enum\Enum\ConfigBackedRoleInterface;
use Drupal\role_enum_test\Permissions\PermissionsOne;
use Drupal\role_enum_test\Permissions\PermissionsTwo;

/**
 * Roles derived from this enum.
 */
enum TestVirtualRoles implements ConfigBackedRoleInterface {

  case Role1;

  #[Permissions(permissions: [
    // Just an enum:
    PermissionsOne::A,
    // All enums in the class:
    PermissionsTwo::class,
    // String, from \Drupal\role_enum_test\Permissions\PermissionsThree:
    'role_enum_test three e',
  ])]
  case Role2;

}
